/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * GeoJSONFeatureCollection
 */

public class GeoJSONFeatureCollection {
  @JsonProperty("features")
  private List<GeoJSONFeature> features = new ArrayList<GeoJSONFeature>();

  /**
   * Gets or Sets type
   */
  public enum TypeEnum {
    FEATURECOLLECTION("FeatureCollection");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  public GeoJSONFeatureCollection features(List<GeoJSONFeature> features) {
    this.features = features;
    return this;
  }

  public GeoJSONFeatureCollection addFeaturesItem(GeoJSONFeature featuresItem) {
    this.features.add(featuresItem);
    return this;
  }

   /**
   * Get features
   * @return features
  **/
  @ApiModelProperty(required = true, value = "")
  public List<GeoJSONFeature> getFeatures() {
    return features;
  }

  public void setFeatures(List<GeoJSONFeature> features) {
    this.features = features;
  }

  public GeoJSONFeatureCollection type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @ApiModelProperty(example = "FeatureCollection", required = true, value = "")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GeoJSONFeatureCollection geoJSONFeatureCollection = (GeoJSONFeatureCollection) o;
    return Objects.equals(this.features, geoJSONFeatureCollection.features) &&
        Objects.equals(this.type, geoJSONFeatureCollection.type);
  }

  @Override
  public int hashCode() {
    return Objects.hash(features, type);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GeoJSONFeatureCollection {\n");

    sb.append("    features: ").append(toIndentedString(features)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

